var gSearchBox;
var gMatchList;
var gMethodList;
var gClearButton;
var gBookmarksView;

// Firefox bookmarks.js
var gNC_NS = "http://home.netscape.com/NC-rdf#";

if (!gPref) {
  var gPref = Components.classes["@mozilla.org/preferences-service;1"]
                        .getService(Components.interfaces.nsIPrefBranch)
                        .QueryInterface(Components.interfaces.nsIPrefBranch);
}

var xsbBookmarks = {

  initPanel : function () {
    window.removeEventListener("load", xsbBookmarks.initPanel, true);
    gSearchBox = document.getElementById("search-box");
    gClearButton = document.getElementById("clearSearch");
    gBookmarksView = document.getElementById("bookmarks-view");

    // Support for libf (Locate in Bookmark Folders)
    BookmarksCommand.NativeCreateContextMenu = BookmarksCommand.createContextMenu;
    BookmarksCommand.createContextMenu = xsbBookmarks.xsbCreateContextMenu;
  },

  initMgr : function () {
    window.removeEventListener("load", xsbBookmarks.initMgr, true);
    gSearchBox = document.getElementById("search-box");
    gMatchList = document.getElementById("xsb-matchList");
    gMethodList = document.getElementById("xsb-methodList");
    gClearButton = document.getElementById("clearSearch");
    gBookmarksView = document.getElementById("bookmarks-view");
    xsbBookmarks.initSettings();
    xsbBookmarks.addPrefObserver();
    xSidebar.extensionStartup();

    var initialRef = gBookmarksView.tree.getAttribute("ref");
    gBookmarksView.tree.setAttribute("ref", "NC:BookmarksTopRoot");
     // Search some dummy variable first to initialize bookmarksTree.xml
    gBookmarksView.searchBookmarks("NC:BookmarksTopRoot");
    gBookmarksView.searchBookmarks();
    gBookmarksView.tree.setAttribute("ref", initialRef);

    // Support for libf (Locate in Bookmark Folders)
    BookmarksCommand.NativeCreateContextMenu = BookmarksCommand.createContextMenu;
    BookmarksCommand.createContextMenu = xsbBookmarks.xsbCreateContextMenu;

    if ("arguments" in window && window.arguments[0] &&
        window.arguments[0].substring(0,5) == "find:") {
      xsbBookmarks.setRoot(window.arguments[0]);
    }
  },

  initSettings : function () {
    var showadvanced = gPref.getBoolPref("extensions.xsidebar.bookmarks.manager.showadvancedsearch");
    xSidebar.showItem("xsb-advancedsearch-box", showadvanced);
    xSidebar.showItem("bookmarks-search", "true");
  },

  unloadMgr : function () {
    xsbBookmarks.removePrefObserver();
  },

  searchBookmarks : function (aInput) {
    xsbBookmarks.setClearButton(aInput);
    gBookmarksView.searchBookmarks(aInput);
  },

  searchBookmarksManager : function (aInput) {
    xsbBookmarks.setClearButton(aInput);
    if (aInput == "") {
      gBookmarksView.searchBookmarks(aInput);
    }
    else if (!xsbBookmarks.advancedSearchMode()) {
      gBookmarksView.searchBookmarks(aInput);
    }
    else {
      var searchURI = "find:datasource=rdf:bookmarks"
      searchURI += "&match=" + gMatchList.selectedItem.value;
      searchURI += "&method=" + gMethodList.selectedItem.value;
      searchURI += "&text=" + encodeURIComponent(aInput);
      gBookmarksView.tree.setAttribute("ref", searchURI);
    }
  },

  advancedSearchMode : function (isAdvanced) {
    var advbox = document.getElementById("xsb-advancedsearch-box");
    if (isAdvanced != null) {
      advbox.hidden = !isAdvanced;
    }
    return !advbox.hidden;
  },

  setRoot : function (root) {
    gBookmarksView.tree.setAttribute("ref", root);
    var findVars = root.split("&");
    for (ii = 0; ii < findVars.length; ii++) {
      findVars[ii] = findVars[ii].split("=")[1];
    }
    //dump("setRoot :"+findVars+"\n");
    gMatchList.value = findVars[1];
    gMethodList.value = findVars[2];
    gSearchBox.value = decodeURIComponent(findVars[3]);
    gClearButton.setAttribute("disabled", "false");
  },

  /// From AIOS
  clearSearch : function() {
    gSearchBox.value = "";
    gSearchBox.focus();
    xsbBookmarks.setClearButton(gSearchBox.value);
    gBookmarksView.searchBookmarks(gSearchBox.value);
  },

  /// xSidebar additions
  setClearButton : function (aInput) {
    gClearButton.setAttribute("disabled", (aInput == "") ? "true" : "false");
  },

  /// From --Locate in Bookmark Folders--

  xsbCreateContextMenu: function (aEvent, aSelection) {

    const XUL_NAMESPACE = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";

    BookmarksCommand.NativeCreateContextMenu(aEvent, aSelection);
    if (!gSearchBox.value)
      return;
    if (!xsbBookmarks.isValidBookmark(aSelection))
      return;

    var popup = aEvent.target;
    var menuItem = document.createElementNS(XUL_NAMESPACE, "menuitem");
    menuItem.setAttribute("observes", "xsbLocateInBookmarkFolder");
    menuItem.setAttribute("oncommand",
      "xsbBookmarks.locateInFolders('" + aSelection.item[0].Value + "');");
    var deleteItems = popup.getElementsByAttribute("command", "cmd_bm_delete");
    popup.insertBefore(menuItem, deleteItems[0].nextSibling);
  },

  isValidBookmark : function(aSelection) {
    return aSelection &&
      (aSelection.length == 1) &&
      (aSelection.item[0] instanceof Components.interfaces.nsIRDFResource) &&
      (aSelection.type == 'Bookmark');
  },

  locateInFolders : function(aResource) {
    var rsrc = RDF.GetResource(aResource);
    // reset the data source of bookmarksView to its original "ref"
    xsbBookmarks.clearSearch();
    // locate the selected resource in the bookmarksView tree
    xsbBookmarks.selectResource(rsrc);
    gBookmarksView.tree.treeBoxObject.ensureRowIsVisible(gBookmarksView.currentIndex);
  },

  /// Preferences

  prefObserver : {
    observe: function(subject, topic, data) {
    // subject is the nsIPrefBranch we're observing (after appropriate QI)
    // data is the name of the pref that's been changed (relative to subject)
      if(topic == "nsPref:changed")
        xsbBookmarks.initSettings();
    },

    QueryInterface : function (aIID) {
      if (aIID.equals(Components.interfaces.nsIObserver) || 
      aIID.equals(Components.interfaces.nsISupports) ||
      aIID.equals(Components.interfaces.nsISupportsWeakReference))
        return this;
      throw Components.results.NS_NOINTERFACE;
    }
  },

  addPrefObserver : function () {
    xSidebar.prefBranch.addObserver("extensions.xsidebar.bookmarks.manager.", xsbBookmarks.prefObserver, true);
  },

  removePrefObserver : function () {
    if (!xSidebar.prefBranch) return;
    xSidebar.prefBranch.removeObserver("extensions.xsidebar.bookmarks.manager.", xsbBookmarks.prefObserver);
  },

  /// FF Compatibility functions
  // from FF tree.xml
  selectResource : function (aResource) {
    var index = gBookmarksView.treeBuilder.getIndexOfResource(aResource);
    //dump(":"+BookmarksUtils.getProperty(aResource, gNC_NS+"Name")+", index:"+index+"\n");
    if (index != -1) {
      if (!gBookmarksView.treeBoxObject.view.selection.isSelected(index))
        gBookmarksView.treeBoxObject.view.selection.toggleSelect(index);
      return;
    }

    var chain = xsbBookmarks.getParentChain(aResource);
    //dump("Chain:"+chain.length+"\n");
    for (var i=0; i<chain.length; i++) {
      //var rParent = chain.queryElementAt(i, kRDFRSCIID); // Not an nsIArray!
      var rParent = chain[i];
      index = gBookmarksView.treeBuilder.getIndexOfResource(rParent);
      //dump(i+":"+BookmarksUtils.getProperty(rParent, gNC_NS+"Name")+", index:"+index+"\n");
      if (index == -1)
        continue;

      if (!gBookmarksView.treeBoxObject.view.isContainerOpen(index))
        gBookmarksView.treeBoxObject.view.toggleOpenState(index);
    }
    if (index == -1)
      return;

    index = gBookmarksView.treeBuilder.getIndexOfResource(aResource);
    if (index != -1) {
      gBookmarksView.treeBoxObject.view.selection.toggleSelect(index);
    }
  },

  // from FF nsBookmarksService.cpp (translated into js)
  getParentChain : function (aResource) {
    var parentArray = new Array();
    if (aResource) {
      var parent = xsbBookmarks.getParent(aResource);
      while (parent) {
        parentArray.unshift(parent);
        parent = xsbBookmarks.getParent(parent);
      }
    }
    return parentArray;
  },

  // from FF nsBookmarksService.cpp (translated into js)
  getParent : function (aResource) {
    var arcsIn = BMDS.ArcLabelsIn(aResource);
    while (arcsIn.hasMoreElements()) {
      var containerArc = arcsIn.getNext();
      // Test if the arc is ordinal. We will assume that the parent is determined
      // by the first ordinal arc that points to the resource.
      // That's not bullet-proof, since several ordinal arcs can point to the same
      // resource. However, this will be sufficient for most of the cases.
      if (RDFCU.IsOrdinalProperty(containerArc)) {
        return BMDS.GetSource(containerArc, aResource, true)
                   .QueryInterface(kRDFRSCIID);
      }
    }
    return null;
  }

}
